# Enum Class VulkanAccessFlag

java.lang.Object
java.lang.Enum<VulkanAccessFlag>
com.io7m.jcoronado.api.VulkanAccessFlag

All Implemented Interfaces:
  `VulkanEnumBitmaskLongType, Serializable, Comparable<VulkanAccessFlag>, Constable`

public enum VulkanAccessFlag extends Enum<VulkanAccessFlag> implements VulkanEnumBitmaskLongType
Bitmask specifying memory access types that will participate in a memory dependency.

See Also:
  - "VkAccessFlagBits"

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `VK_ACCESS_COLOR_ATTACHMENT_READ_BIT`
  VK_ACCESS_2_COLOR_ATTACHMENT_READ_BIT
  `VK_ACCESS_COLOR_ATTACHMENT_WRITE_BIT`
  VK_ACCESS_2_COLOR_ATTACHMENT_WRITE_BIT
  `VK_ACCESS_DEPTH_STENCIL_ATTACHMENT_READ_BIT`
  VK_ACCESS_2_DEPTH_STENCIL_ATTACHMENT_READ_BIT
  `VK_ACCESS_DEPTH_STENCIL_ATTACHMENT_WRITE_BIT`
  VK_ACCESS_2_DEPTH_STENCIL_ATTACHMENT_WRITE_BIT
  `VK_ACCESS_HOST_READ_BIT`
  VK_ACCESS_2_HOST_READ_BIT
  `VK_ACCESS_HOST_WRITE_BIT`
  VK_ACCESS_2_HOST_WRITE_BIT
  `VK_ACCESS_INDEX_READ_BIT`
  VK_ACCESS_2_INDEX_READ_BIT
  `VK_ACCESS_INDIRECT_COMMAND_READ_BIT`
  VK_ACCESS_2_INDIRECT_COMMAND_READ_BIT
  `VK_ACCESS_INPUT_ATTACHMENT_READ_BIT`
  VK_ACCESS_2_INPUT_ATTACHMENT_READ_BIT
  `VK_ACCESS_MEMORY_READ_BIT`
  VK_ACCESS_2_MEMORY_READ_BIT
  `VK_ACCESS_MEMORY_WRITE_BIT`
  VK_ACCESS_2_MEMORY_WRITE_BIT
  `VK_ACCESS_NONE`
  VK_ACCESS_2_NONE
  `VK_ACCESS_SHADER_READ_BIT`
  VK_ACCESS_2_SHADER_READ_BIT
  `VK_ACCESS_SHADER_SAMPLED_READ_BIT`
  VK_ACCESS_2_SHADER_SAMPLED_READ_BIT
  `VK_ACCESS_SHADER_STORAGE_READ_BIT`
  VK_ACCESS_2_SHADER_STORAGE_READ_BIT
  `VK_ACCESS_SHADER_STORAGE_WRITE_BIT`
  VK_ACCESS_2_SHADER_STORAGE_WRITE_BIT
  `VK_ACCESS_SHADER_WRITE_BIT`
  VK_ACCESS_2_SHADER_WRITE_BIT
  `VK_ACCESS_TRANSFER_READ_BIT`
  VK_ACCESS_2_TRANSFER_READ_BIT
  `VK_ACCESS_TRANSFER_WRITE_BIT`
  VK_ACCESS_2_TRANSFER_WRITE_BIT
  `VK_ACCESS_UNIFORM_READ_BIT`
  VK_ACCESS_2_UNIFORM_READ_BIT
  `VK_ACCESS_VERTEX_ATTRIBUTE_READ_BIT`
  VK_ACCESS_2_VERTEX_ATTRIBUTE_READ_BIT

- ## Method Summary

  Modifier and Type
  Method
  Description
  `long`
  `value()`
  `static VulkanAccessFlag`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static VulkanAccessFlag[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### VK_ACCESS_COLOR_ATTACHMENT_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_COLOR_ATTACHMENT_READ_BIT
    VK_ACCESS_2_COLOR_ATTACHMENT_READ_BIT

  - ### VK_ACCESS_COLOR_ATTACHMENT_WRITE_BIT

    public static final VulkanAccessFlag VK_ACCESS_COLOR_ATTACHMENT_WRITE_BIT
    VK_ACCESS_2_COLOR_ATTACHMENT_WRITE_BIT

  - ### VK_ACCESS_DEPTH_STENCIL_ATTACHMENT_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_DEPTH_STENCIL_ATTACHMENT_READ_BIT
    VK_ACCESS_2_DEPTH_STENCIL_ATTACHMENT_READ_BIT

  - ### VK_ACCESS_DEPTH_STENCIL_ATTACHMENT_WRITE_BIT

    public static final VulkanAccessFlag VK_ACCESS_DEPTH_STENCIL_ATTACHMENT_WRITE_BIT
    VK_ACCESS_2_DEPTH_STENCIL_ATTACHMENT_WRITE_BIT

  - ### VK_ACCESS_HOST_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_HOST_READ_BIT
    VK_ACCESS_2_HOST_READ_BIT

  - ### VK_ACCESS_HOST_WRITE_BIT

    public static final VulkanAccessFlag VK_ACCESS_HOST_WRITE_BIT
    VK_ACCESS_2_HOST_WRITE_BIT

  - ### VK_ACCESS_INDEX_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_INDEX_READ_BIT
    VK_ACCESS_2_INDEX_READ_BIT

  - ### VK_ACCESS_INDIRECT_COMMAND_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_INDIRECT_COMMAND_READ_BIT
    VK_ACCESS_2_INDIRECT_COMMAND_READ_BIT

  - ### VK_ACCESS_INPUT_ATTACHMENT_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_INPUT_ATTACHMENT_READ_BIT
    VK_ACCESS_2_INPUT_ATTACHMENT_READ_BIT

  - ### VK_ACCESS_MEMORY_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_MEMORY_READ_BIT
    VK_ACCESS_2_MEMORY_READ_BIT

  - ### VK_ACCESS_MEMORY_WRITE_BIT

    public static final VulkanAccessFlag VK_ACCESS_MEMORY_WRITE_BIT
    VK_ACCESS_2_MEMORY_WRITE_BIT

  - ### VK_ACCESS_NONE

    public static final VulkanAccessFlag VK_ACCESS_NONE
    VK_ACCESS_2_NONE

  - ### VK_ACCESS_SHADER_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_SHADER_READ_BIT
    VK_ACCESS_2_SHADER_READ_BIT

  - ### VK_ACCESS_SHADER_SAMPLED_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_SHADER_SAMPLED_READ_BIT
    VK_ACCESS_2_SHADER_SAMPLED_READ_BIT

  - ### VK_ACCESS_SHADER_STORAGE_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_SHADER_STORAGE_READ_BIT
    VK_ACCESS_2_SHADER_STORAGE_READ_BIT

  - ### VK_ACCESS_SHADER_STORAGE_WRITE_BIT

    public static final VulkanAccessFlag VK_ACCESS_SHADER_STORAGE_WRITE_BIT
    VK_ACCESS_2_SHADER_STORAGE_WRITE_BIT

  - ### VK_ACCESS_SHADER_WRITE_BIT

    public static final VulkanAccessFlag VK_ACCESS_SHADER_WRITE_BIT
    VK_ACCESS_2_SHADER_WRITE_BIT

  - ### VK_ACCESS_TRANSFER_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_TRANSFER_READ_BIT
    VK_ACCESS_2_TRANSFER_READ_BIT

  - ### VK_ACCESS_TRANSFER_WRITE_BIT

    public static final VulkanAccessFlag VK_ACCESS_TRANSFER_WRITE_BIT
    VK_ACCESS_2_TRANSFER_WRITE_BIT

  - ### VK_ACCESS_UNIFORM_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_UNIFORM_READ_BIT
    VK_ACCESS_2_UNIFORM_READ_BIT

  - ### VK_ACCESS_VERTEX_ATTRIBUTE_READ_BIT

    public static final VulkanAccessFlag VK_ACCESS_VERTEX_ATTRIBUTE_READ_BIT
    VK_ACCESS_2_VERTEX_ATTRIBUTE_READ_BIT

- ## Method Details

  - ### values

    public static VulkanAccessFlag[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static VulkanAccessFlag valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### value

    public long value()
    Specified by:
      `value` in interface `VulkanEnumBitmaskLongType`
    Returns:
      The integer value of the constant